<?php
function stripNonText($text) {
	if ($text != '')
	{
		return preg_replace(array('@<script[^>]*?>.*?</script>@si', '@<[\/\!]*?[^<>]*?>@si'), array('', ''), $text);
	}
	
	return '';
}

function extractArgument($params, $name)
{
	$ix = -1;
	$iy = -1;
	if (strlen($params) != 0)
	{
		$args = strtolower($params);
		$arg = strtolower($name).'=';
		$ix = strpos($args, $arg);
		if ($ix > 0)
		{
			$ix = $ix + strlen($arg);
			$iy = strpos(substr($args, $ix, strlen($args)), '&');
			if (!$iy)
			{
				$iy = strlen($args);
			}
		}
	}
	return $argument = ($ix > 0) ? substr($params, $ix, $iy) : '';
}

function getWeekRange($offset=0)
{
	$start_date = '';
	$end_date = '';   
	$week = date('W');
	$week = $week - $offset;
	$date = date('Y-m-d');
   
	$i = 0;
	while(date('W', strtotime("-$i day")) >= $week)
	{                       
		$start_date = date('Y-m-d', strtotime("-$i day"));
		$i++;       
	}   
	   
	list($yr, $mo, $da) = explode('-', $start_date);   
	$end_date = date('Y-m-d', mktime(0, 0, 0, $mo, $da + 6, $yr));
	
	return array($start_date, $end_date);
}

function getMonthRange($offset=0)
{
	$start_date = '';
	$end_date = '';   
	$date = date('Y-m-d');
   
	list($yr, $mo, $da) = explode('-', $date);
	$start_date = date('Y-m-d', mktime(0, 0, 0, $mo - $offset, 1, $yr));
   
	$i = 2;
   
	list($yr, $mo, $da) = explode('-', $start_date);
   
	while(date('d', mktime(0, 0, 0, $mo, $i, $yr)) > 1)
	{
		$end_date = date('Y-m-d', mktime(0, 0, 0, $mo, $i, $yr));
		$i++;
	}
	
	return array($start_date, $end_date);
}

function get_sql_top_selling($range = array())
{	
	$sql = 'SELECT count(prodid) as total_download, prodid as id, b.name, LEFT(b.description, 80) as description, b.image ';
	$sql .= 'FROM ' . WPSC_TABLE_CART_CONTENTS . ' a, ' . WPSC_TABLE_PRODUCT_LIST . ' b, ' . WPSC_TABLE_DOWNLOAD_STATUS . ' c ';
	$sql .= 'WHERE a.prodid = b.id AND a.id = c.cartid AND b.publish = 1 AND b.active = 1 ';
	if (is_array($range) && count($range) > 0)
	{
		$sql .= 'AND (DATE_FORMAT(datetime, "%Y-%m-%d") BETWEEN "' . $range[0] . '" AND "' . $range[1] . '") ';
	}
	$sql .= 'GROUP BY prodid ORDER BY total_download DESC';
	
	return $sql;
}

function icl_get_categories($limit_start = '', $limit_end = '')
{
	global $wpdb;
	
	$category_list = array();
	
	$sql = 'SELECT ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id, ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.name, `nice-name` FROM '. WPSC_TABLE_PRODUCT_CATEGORIES . ' ';
	$sql .= 'LEFT JOIN ' . WPSC_TABLE_CATEGORISATION_GROUPS . ' ON ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.group_id = ' . WPSC_TABLE_CATEGORISATION_GROUPS . '.id ';
	$sql .= 'WHERE LOWER(' . WPSC_TABLE_CATEGORISATION_GROUPS . '.name) != "brands" AND `nice-name` NOT IN ("featured", "horizontal", "vertical") AND ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.active = 1 ';
	if ($limit_end != '')
	{
		$sql .= 'LIMIT ' . $limit_start . ', ' . $limit_end;
	}
	
	$categories = $wpdb->get_results($sql, ARRAY_A);
	if($categories != null)
	{
		foreach($categories as $category)
		{
			$category_list[] = $category;
		}
		return $category_list;
	}
	
	return $category_list;
}

function icl_get_category($category)
{
	global $wpdb;
	
	$sql = 'SELECT id, name, `nice-name` FROM '. WPSC_TABLE_PRODUCT_CATEGORIES . ' ';
	$sql .= 'WHERE id = ' . $category;
	
	$categories = $wpdb->get_results($sql, ARRAY_A);
	if(is_array($categories) && count($categories) > 0)
	{
		return $categories[0];
	}
	
	return array();
}

function icl_get_category_nicename($category)
{
	global $wpdb;
	
	$sql = 'SELECT `nice-name` FROM '. WPSC_TABLE_PRODUCT_CATEGORIES . ' ';
	$sql .= 'WHERE id = ' . $category;
	
	$categories = $wpdb->get_results($sql, ARRAY_A);
	if(is_array($categories) && count($categories) > 0)
	{
		return $categories[0]['nice-name'];
	}
	
	return '';
}

function icl_output_get_categories($product, $separator = '', $prefix = '', $suffix = '')
{
	global $wpdb;
	
	$sql = 'SELECT ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id, name FROM '. WPSC_TABLE_PRODUCT_ORDER . ' ';
	$sql .= 'LEFT JOIN ' . WPSC_TABLE_PRODUCT_CATEGORIES . ' ON ' . WPSC_TABLE_PRODUCT_ORDER . '.category_id = ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id ';
	$sql .= 'WHERE product_id = ' . $product . ' AND LOWER(name) NOT IN ("featured", "horizontal", "vertical")';
	
	$categories = $wpdb->get_results($sql, ARRAY_A);
	if($categories != null)
	{
		$category_list = array();
		foreach($categories as $category)
		{
			$category_list[] = $prefix.$category['name'].$suffix;
		}
		return implode(', ', $category_list);
	}
	
	return '';
}

function icl_output_get_categories_id($product, $separator = '')
{
	global $wpdb;
	
	$sql = 'SELECT ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id FROM '. WPSC_TABLE_PRODUCT_ORDER . ' ';
	$sql .= 'LEFT JOIN ' . WPSC_TABLE_PRODUCT_CATEGORIES . ' ON ' . WPSC_TABLE_PRODUCT_ORDER . '.category_id = ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id ';
	$sql .= 'WHERE product_id = ' . $product . ' AND LOWER(name) NOT IN ("featured", "horizontal", "vertical")';
	
	$categories = $wpdb->get_results($sql, ARRAY_A);
	if($categories != null)
	{
		$category_list = array();
		foreach($categories as $category)
		{
			$category_list[] = $category['id'];
		}
		return implode($separator, $category_list);
	}
	
	return '';
}

function icl_is_horizontal($product)
{
	global $wpdb;
	
	$sql = 'SELECT ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id FROM '. WPSC_TABLE_PRODUCT_ORDER . ' ';
	$sql .= 'LEFT JOIN ' . WPSC_TABLE_PRODUCT_CATEGORIES . ' ON ' . WPSC_TABLE_PRODUCT_ORDER . '.category_id = ' . WPSC_TABLE_PRODUCT_CATEGORIES . '.id ';
	$sql .= 'WHERE product_id = ' . $product . ' AND LOWER(name) = "horizontal"';
	
	$product = $wpdb->get_results($sql, ARRAY_A);
	if (is_array($product) && count($product) > 0)
	{
		return TRUE;
	}
	
	return FALSE;
}

function icl_dashboard_news_list()
{
	$rss = @fetch_feed('http://feeds.feedburner.com/iclportfolio');
	
	if ( is_wp_error($rss) )
	{
		if ( is_admin() || current_user_can('manage_options') ){
			echo '<div class="rss-widget"><p>';
			printf(__('<strong>RSS Error</strong>: %s'), $rss->get_error_message());
			echo '</p></div>';
		}
	} elseif ( !$rss->get_item_quantity() ) {
		return false;
	} else {
		echo '<div class="rss-widget">';
		wp_widget_rss_output( $rss, array('items' => 5, 'show_summary' => TRUE, 'show_date' => TRUE) );
		echo '</div>';
	}
}

function create_post_string($method, $params, $sc) {
	$params['method'] = $method;
	if (!isset($params['v']))
	{
		$params['v'] = '1.0';
	}
	$post_params = array();
	foreach ($params as $key => &$val)
	{
		if (is_array($val)) $val = implode(',', $val);
		$post_params[] = $key.'='.urlencode($val);
	}
	$post_params[] = 'sig='.generate_sig($params, $sc);
	return implode('&', $post_params);
}

function generate_sig($params_array, $sc) {
	$str = '';
	ksort($params_array);
	foreach ($params_array as $k=>$v)
	{
		$str .= "$k=$v";
	}
	$str .= $sc;
	return md5($str);
}

function ping($address, $method, $params, $sc)
{
	$post_string = create_post_string($method, $params, $sc);
	if (function_exists('curl_init'))
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $address);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_string);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_USERAGENT, 'ICL API Client 1.0 (curl) ' . phpversion());
		$result = curl_exec($ch);
		curl_close($ch);
	}
	else
	{
		$context =
			array('http' =>
				array('method' => 'POST',
					'header' => 'Content-type: application/x-www-form-urlencoded'."\r\n".
								'User-Agent: ICL API Client 1.0 (non-curl) '.phpversion()."\r\n".
								'Content-length: ' . strlen($post_string),
					'content' => $post_string));
		$contextid=stream_context_create($context);
		$sock=fopen($address, 'r', false, $contextid);
		if ($sock) {
			$result='';
			while (!feof($sock))
				$result.=fgets($sock, 4096);
			fclose($sock);
		}
	}
	return $result;
}

function icl_general()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/1.png" alt="Appcloud Premium Preview" /></a>';
}

function icl_menu()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/2.png" alt="Appcloud Premium Preview" /></a>';
}

function icl_categories()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/3.png" alt="Appcloud Premium Preview" /></a>';
}

function icl_products()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/4.png" alt="Appcloud Premium Preview" /></a>';
}

function icl_price_rules()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/5.png" alt="Appcloud Premium Preview" /></a>';
}

function icl_banner()
{
	echo '<a href="http://portfolio.icreativelabs.com/wordpress/premium/appcloud/" target="_blank"><img src="http://ping.icreativelabs.com/previews/appcloud/6.png" alt="Appcloud Premium Preview" /></a>';
}
?>