<?php
	require_once(dirname(__FILE__) . '/includes/functions.php');
	
	$query_string = '&'.urldecode($query_string);
	
	$current_page = stripNonText(extractArgument('&'.$query_string, 'pagename'));
	
	get_header();
	
	$show_full_page = TRUE;
	
	if (preg_match("/products-page/i", $current_page))
	{
		$show_full_page = FALSE;
		if (preg_match("/your-account/i", $current_page))
		{
			$show_full_page = TRUE;
		}
	}
	
	if ($show_full_page)
	{
		$i_product = 1;
		$limit = 10;
		
		$sql = 'SELECT id, image ';
		$sql .= 'FROM ' . WPSC_TABLE_PRODUCT_LIST .' ';
		$sql .= 'WHERE publish = 1 AND active = 1 ';
		$sql .= 'ORDER BY RAND() LIMIT ' . $limit;
		
		$wpsc_query->products = $wpdb->get_results($sql, ARRAY_A);
		$wpsc_query->product_count = count($wpsc_query->products);
	}
?>
	
	<div class="wrap0top"></div><!-- wrap0 -->
	<div class="wrap0">
		<div class="wrapin">
			<?php if ($show_full_page) : ?>
			<div class="random">
				<ul>
					<?php while (wpsc_have_products()) :  wpsc_the_product(); ?>
					<li<?php if($i_product == $limit) :?>class="no"<?php endif; ?>>
						<a href="<?php echo wpsc_the_product_permalink(); ?>">
						<?php if(get_option('show_thumbnails')) :?>
						<?php if(wpsc_the_product_thumbnail()) :?>
							<img id="product_image_<?php echo wpsc_the_product_id(); ?>" alt="<?php echo wpsc_the_product_title(); ?>" title="<?php echo wpsc_the_product_title(); ?>" src="<?php echo wpsc_the_product_thumbnail(); ?>" width="62" height="62" />
						<?php else: ?>
							<span>No Image Available</span>
						<?php endif; ?>
						<?php endif; ?>
						</a>
					</li>
					<?php ++$i_product; ?>
					<?php endwhile; ?>
				</ul>
			</div>
			<div class="clear"></div>
			<div class="faq">
			<?php if (have_posts()) : ?>
				<h3><?php the_title(); ?></h3>
				<?php while (have_posts()) : the_post(); ?>
					<?php the_content("Continue reading&hellip;"); ?>
					<?php wp_link_pages(array('before' => '<p><strong>Pages:</strong> ', 'after' => '</p>', 'next_or_number' => 'number')); ?>
				<?php endwhile; ?>
			<?php else : ?>
				<?php /* Error 404 */ ?>	
				<?php $filename = TEMPLATEPATH . '/404.php'; if (file_exists($filename)) { include($filename); } ?>
			<?php endif; ?>
			</div>
			<?php else : ?>
			<script type="text/javascript" charset="utf-8">
			function setEqualHeight(columns) {
				var tallestcolumn = 0;
				columns.each(
					function() {
						currentHeight = jQuery(this).height();
						if(currentHeight > tallestcolumn) {
							tallestcolumn  = currentHeight;
						}
					}
				);
				columns.height(tallestcolumn);
				delete tallestcolumn;
			}

			jQuery(document).ready(function() {
				setEqualHeight(jQuery(".wrapin  > div"));
			});
			</script>
			<div class="mainbar<?php echo ((preg_match("/checkout/i", $current_page)) ? ' check' : ''); ?>">
				<?php if (have_posts()) : ?>
					<?php while (have_posts()) : the_post(); ?>
						<?php the_content("Continue reading&hellip;"); ?>
					<?php endwhile; ?>
				<?php else : ?>
					<?php /* Error 404 */ ?>	
					<?php $filename = TEMPLATEPATH . '/404.php'; if (file_exists($filename)) { include($filename); } ?>
				<?php endif; ?>
			</div>
			<?php get_sidebar(); ?>
			<?php endif; ?>
			<span class="clear"></span>
		</div>
	</div>
	<div class="wrap0bot"></div>

<?php get_footer(); ?>